unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Edit1: TEdit;
    Memo1: TMemo;
    Button2: TButton;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure Compter(F: TStringList; Tag: string);
var i, cnt, cnt1, cnt2, p: integer;
    TagDebut, TagFin, S: string;
begin
  // Prparer les tags (on ne gre pas la fin > car il peut y avoir des options derrire le tag...
  // donc attention, il pourrait mal compter certains tags, par exemple, il pourrait confondre
  // <B> avec <BONJOUR> (mais pas l'inverse)...  amliorer si vous le voulez
  // (pour amliorer a il faudrait faire un algorithme qui enlve ce qui est entre un < et un >,
  // mais qui garde le 1er mot; ou refaire l'algorithme en regardant chaque tag un par un pour voir
  // s'il s'agit du tag demand ou non
  TagDebut:='<'+lowercase(Tag);
  TagFin:='</'+lowercase(Tag);

  // Mise en minuscule, comme TagDebut et TagFin, parcequ'un tag <TABLE> est le mme qu'un
  // tag <table>
  for i:=0 to F.Count-1 do F[i]:=lowercase(F[i]);

  // On enlve tous les espaces, parcequ'un tag < TABLE > est le mme qu'un tag <TABLE>
  for i:=0 to F.Count-1 do
  begin
    // Il me semble qu'il est plus rapide de travailler  partir d'un string que d'un
    // tableau de string directement, donc par souci d'optimisation je copie la ligne
    // dans un string temporaire (S)
    S:=F[i];
    p:=pos(' ', S);
    while p>0 do
    begin
      // On enlve l'espace qui se trouve  la position p en copiant ce qui est  gauche,
      // ce qui est  droite, et en collant le tout
      S:=copy(S, 1, p-1)+copy(S, p+1, length(S));
      p:=pos(' ', S);
    end;
    F[i]:=S;
  end;

  // On va enfin pouvoir compter les tags, donc on met les compteurs  0
  cnt1:=0;
  cnt2:=0;

  // On compte ligne par ligne
  for i:=0 to F.Count-1 do
  begin
    // Idem qu'au-dessus, je pense qu'il est plus rapide de travailler  partir d'un string
    // que d'un TStringList
    S:=F[i];
    // Tant qu'il reste un tag de dbut, on incrmente le compteur et on le supprime
    while pos(TagDebut, S)>0 do
    begin
      // En fait on supprime tout ce qui est  gauche du tag
      S:=copy(S, pos(TagDebut, S)+length(TagDebut), length(S));
      inc(cnt1);
    end;

    // Et maintenant on compte les tags de fin
    S:=F[i];
    while pos(TagFin, S)>0 do
    begin
      S:=copy(S, pos(TagFin, S)+length(TagFin), length(S));
      inc(cnt2);
    end;
  end;

  // On fait la diffrence
  cnt:=cnt1-cnt2;

  // On prpare un compte-rendu; les #13 permettent de sauter une ligne
  S:='Nombre de tags '+TagDebut+'>: '+inttostr(cnt1)+#13+
     'Nombre de tags '+TagFin+'>: '+inttostr(cnt2)+#13+
     'Diffrence: '+inttostr(cnt)+#13+#13;

  // Et l on affiche le compte-rendu avec un message de conclusion
  if cnt=0 then showmessage(S+'Les tags '+TagDebut+'> sont bien quilibrs.');
  if cnt>0 then showmessage(S+'Les tags '+TagDebut+'> sont trop nombreux. Il manque '+inttostr(cnt)+' tags '+TagFin+'>.');
  if cnt<0 then showmessage(S+'Il y a '+inttostr(-cnt)+' tags '+TagFin+'> de trop.');
end;

procedure TForm1.Button1Click(Sender: TObject);
var F: TStringList;
    i, cnt, cnt1, cnt2, p: integer;
    TagDebut, TagFin, S: string;
begin
  if OpenDialog1.Execute then
  begin
    F:=TStringList.Create;
    F.LoadFromFile(OpenDialog1.FileName);
    Compter(F, Edit1.Text);
    F.Free;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var SL: TStringList;
begin
  SL:=TStringList.Create;
  SL.Assign(Memo1.Lines);
  Compter(SL, Edit1.Text);
  SL.Free;
end;

end.

